VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmRegistry 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Registry Servers"
   ClientHeight    =   2535
   ClientLeft      =   45
   ClientTop       =   495
   ClientWidth     =   4215
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   169
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   281
   StartUpPosition =   1  'CenterOwner
   Visible         =   0   'False
   Begin VB.ComboBox cmbServers 
      Height          =   315
      ItemData        =   "frmRegistry.frx":0000
      Left            =   120
      List            =   "frmRegistry.frx":0002
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   120
      Width           =   3975
   End
   Begin VB.TextBox txtDescription 
      Height          =   1215
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   720
      Width           =   3975
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "C&ancel"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   2040
      Width           =   1215
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "&Connect"
      Height          =   375
      Left            =   2880
      TabIndex        =   1
      Top             =   2040
      Width           =   1215
   End
   Begin MSWinsockLib.Winsock Socket 
      Left            =   0
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      RemoteHost      =   "pengwy.servegame.com"
      RemotePort      =   5679
   End
   Begin VB.Label lblTileset 
      Caption         =   "Tileset Number: 0"
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   480
      Width           =   3495
   End
End
Attribute VB_Name = "frmRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Servers() As Server
Dim ServerCount As Long

Private Type Server
    ID As String
    IP As String
    Name As String
    Description As String
    Tileset As Byte
End Type

Private Sub cmbServers_Click()
    txtDescription.Text = Servers(cmbServers.ListIndex).Description
    lblTileset.Caption = "Tileset Number: " & Servers(cmbServers.ListIndex).Tileset
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdConnect_Click()
    If cmbServers.ListIndex < 0 Then
        MsgBox "Please select a server to connect to."
    Else
        With frmMain
            .Disconnect
            .txtServerID.Text = Servers(cmbServers.ListIndex).ID
            .txtIP.Text = Servers(cmbServers.ListIndex).IP
            .txtTileset.Text = Servers(cmbServers.ListIndex).Tileset
            .cmdConnect.Caption = "Loading Odyssey..."
            Shell App.Path & "\odyssey.bin " & Chr$(34) & .txtServerID.Text & Chr$(34) & " 127.0.0.1 " & Chr$(34) & .txtTileset.Text & Chr$(34), vbNormalFocus
            .cmdConnect.Caption = "Please Login"
        End With
        Unload Me
    End If
End Sub

Private Sub Form_Load()
    ServerCount = 0
    ReDim Servers(0 To 0)
    Socket.Connect
End Sub

Private Sub Socket_Connect()
    Socket.SendData Chr$(0) & Chr$(2) & Chr$(3) & Chr$(1)
End Sub

Private Sub Socket_DataArrival(ByVal bytesTotal As Long)
    Dim ServerBreak As Long, DataBreak As Long
    Dim Data As String
    
    Socket.GetData Data
    Socket.SendData Chr$(0) & Chr$(1) & Chr$(4)
    DoEvents    ''Send the data before closing socket
    Socket.Close
    DoEvents
    
    Data = Mid$(Data, InStr(Data, Chr$(4)) + 1)
    
    While Len(Data) > 0
        ReDim Preserve Servers(0 To ServerCount)
        
        DataBreak = InStr(Data, Chr$(0))
        Servers(ServerCount).ID = Left$(Data, DataBreak - 1)
        Data = Mid$(Data, DataBreak + 1)
        
        DataBreak = InStr(Data, Chr$(0))
        Servers(ServerCount).IP = Left$(Data, DataBreak - 1)
        Data = Mid$(Data, DataBreak + 1)
        
        DataBreak = InStr(Data, Chr$(0))
        Servers(ServerCount).Name = Left$(Data, DataBreak - 1)
        Data = Mid$(Data, DataBreak + 1)
        
        DataBreak = InStr(Data, Chr$(0))
        Servers(ServerCount).Description = Left$(Data, DataBreak - 1)
        Data = Mid$(Data, DataBreak + 1)
        
        Servers(ServerCount).Tileset = Asc(Mid$(Data, 2, 1))
        
        cmbServers.AddItem Servers(ServerCount).Name
        
        ServerBreak = InStr(Data, Chr$(4))
        Data = Mid$(Data, ServerBreak + 1)
        ServerCount = ServerCount + 1
    Wend
    
    If cmbServers.ListCount > 0 Then cmbServers.ListIndex = 0
End Sub

Private Sub Socket_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    MsgBox "Cannot connect to registry!"
End Sub
